package com.eco.plugin.xx.hlzjsso.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "单点登录配置")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.eco.plugin.xx.hlzjsso.config", text = "单点登录配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "secret", name = "私钥", description = "私钥", status = Status.SHOW)
    private Conf<String> secret = Holders.simple("");

    @Identifier(value = "paramname", name = "token参数名", description = "token参数名", status = Status.SHOW)
    private Conf<String> paramname = Holders.simple("");

    @Identifier(value = "timeout", name = "token超时时间(s)", description = "token超时时间(s)", status = Status.SHOW)
    private Conf<String> timeout = Holders.simple("");

    @Identifier(value = "hz", name = "账号转化后缀", description = "账号转化后缀", status = Status.SHOW)
    private Conf<String> hz = Holders.simple("A");

    @Identifier(value = "isAll", name = "白名单功能开关", description = "白名单功能开关", status = Status.SHOW)
    private Conf<Boolean> isAll = Holders.simple(true);

    @Identifier(value = "isPt", name = "普通用户权限控制开关", description = "普通用户权限控制开关", status = Status.SHOW)
    private Conf<Boolean> isPt = Holders.simple(true);

    @Identifier(value = "isAdmin", name = "管理员权限控制开关", description = "管理员权限控制开关", status = Status.SHOW)
    private Conf<Boolean> isAdmin = Holders.simple(true);

    @Identifier(value = "zhzh", name = "账户转化开关", description = "账户转化开关", status = Status.SHOW)
    private Conf<Boolean> zhzh = Holders.simple(true);

    @Identifier(value = "白名单配置", name = "白名单配置", description = "白名单配置", status = Status.SHOW)
    private Conf<String> white = Holders.simple("");

    public String getHz() {
        return hz.get();
    }

    public void setHz(String url) {
        this.hz.set(url);
    }

    public Boolean getIsAll() {
        return isAll.get();
    }

    public void setIsAll(Boolean url) {
        this.isAll.set(url);
    }

    public Boolean getIsPt() {
        return isPt.get();
    }

    public void setIsPt(Boolean url) {
        this.isPt.set(url);
    }

    public Boolean getIsAdmin() {
        return isAdmin.get();
    }

    public void setIsAdmin(Boolean url) {
        this.isAdmin.set(url);
    }

    public Boolean getZhzh() {
        return zhzh.get();
    }

    public void setZhzh(Boolean url) {
        this.zhzh.set(url);
    }

    public String getWhite() {
        return white.get();
    }

    public void setWhite(String url) {
        this.white.set(url);
    }

    public String getSecret() {
        return secret.get();
    }

    public void setSecret(String url) {
        this.secret.set(url);
    }

    public String getParamname() {
        return paramname.get();
    }

    public void setParamname(String url) {
        this.paramname.set(url);
    }

    public String getTimeout() {
        return timeout.get();
    }

    public void setTimeout(String url) {
        this.timeout.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
